//===========================================================================
//  @(#) $Name: arts++-1-1-a6 $
//  @(#) $Id: ArtsPackageVersion.hh,v 1.2 2000/01/21 12:21:56 dwm Exp $
//===========================================================================
//  CAIDA Copyright Notice
//
//  By accessing this software, cflowd++, you are duly informed
//  of and agree to be bound by the conditions described below in this
//  notice:
//
//  This software product, cflowd++, is developed by Daniel W. McRobb, and
//  copyrighted(C) 1998 by the University of California, San Diego
//  (UCSD), with all rights reserved.  UCSD administers the CAIDA grant,
//  NCR-9711092, under which part of this code was developed.
//
//  There is no charge for cflowd++ software. You can redistribute it
//  and/or modify it under the terms of the GNU General Public License,
//  v.  2 dated June 1991 which is incorporated by reference herein.
//  cflowd++ is distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
//  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use
//  of it will not infringe on any third party's intellectual property
//  rights.
//
//  You should have received a copy of the GNU GPL along with cflowd++.
//  Copies can also be obtained from:
//
//    http://www.gnu.org/copyleft/gpl.html
//
//  or by writing to:
//
//    University of California, San Diego
//
//    SDSC/CAIDA
//    9500 Gilman Dr., MS-0505
//    La Jolla, CA 92093 - 0505  USA
//
//  Or contact:
//
//    info@caida.org
//===========================================================================

#ifndef _ARTSPACKAGEVERSION_HH_
#define _ARTSPACKAGEVERSION_HH_

#include <string>

//---------------------------------------------------------------------------
//  class ArtsPackageVersion
//---------------------------------------------------------------------------
//!  Simple class for keeping CVS Name and Id tags so they can be
//!  retrieved from applications.  The use of this class is trivial, and
//!  it's not a very smart (robust) class.  To use it properly, you must
//!  pass a string of the form:
//! 
//!  "@(#) $Name: arts++-1-1-a6 $ $Id: ArtsPackageVersion.hh,v 1.2 2000/01/21 12:21:56 dwm Exp $"
//!
//!  in the constructor, and then you may access the value of the Name tag
//!  via the Name() member and the Id tag via the Id() member.
//!
//!  In typical use, I keep a static const string named 'rcsid' in .cc
//!  files.  If the .cc file is the main application, I instantiate an
//!  ArtsPackageVersion by passing rcsid in the ArtsPackageVersion
//!  constructor.
//---------------------------------------------------------------------------
class ArtsPackageVersion
{
public:
  //-------------------------------------------------------------------------
  //                 ArtsPackageVersion(const string & nameAndId)
  //.........................................................................
  //!  constructor.  Takes a string of the form:
  //! 
  //!  "@(#) $Name: arts++-1-1-a6 $ $Id: ArtsPackageVersion.hh,v 1.2 2000/01/21 12:21:56 dwm Exp $"
  //-------------------------------------------------------------------------
  ArtsPackageVersion(const string & nameAndId);

  //-------------------------------------------------------------------------
  //                       const string & Name() const
  //.........................................................................
  //!  Returns the value of the Name tag.
  //-------------------------------------------------------------------------
  const string & Name() const;

  //-------------------------------------------------------------------------
  //                        const string & Id() const
  //.........................................................................
  //!  Returns the value of the Id tag.
  //-------------------------------------------------------------------------
  const string & Id() const;

private:
  string   _name;
  string   _id;
};


#endif  // _ARTSPACKAGEVERSION_HH_
